<template lang="pug">
  .el-menu.mobile-menu

    el-button.burger.no-view(
      v-scroll="burgerShow"
      @click="mobileMenuView = !mobileMenuView"
      aria-label="Открыть меню")

    transition(name="menu-slide" mode="out-in")

      .el-menu__item-wrapper(
        v-show="mobileMenuView")

        .mobile-menu__logo(
          v-if="$route.path === '/'")
          img(
          src="/img/logo.png"
          alt="АО Шувалово")

        .mobile-menu__logo(v-if="$route.path !== '/'")
          nuxt-link(
            to="/")
            img(
              @click='mobileMenuView = false'
              src="/img/logo.png"
              alt="АО Шувалово")

        .el-menu-item(
          v-for="item in navLinks"
          :key="`link-${item.index}`"
          :index='String(item.index)'
          @click='mobileMenuView = false'
          :class="$route.path.includes(item.path) ? 'active-item' : ''")

          nuxt-link(:to="item.path") {{ item.name }}

        .el-menu-item(:class="$route.path === '/user-profile' ? 'active-item' : ''")
          app-profile-panel(
            buttonColor="color: #fcf6db"
            @popover-click="popoverClick"
            @user-exit="userExit"
            trigger="click")

    transition(name="fade")
      .menu-substrate(
        v-if="mobileMenuView"
        @click="mobileMenuView = false")

</template>

<script>
import ProfilePanel from './ProfilePanel';

export default {
  name: 'MobileMenu',
  components: {
    'app-profile-panel': ProfilePanel
  },
  props: {
    navLinks: {
      type: Array,
      required: true
    }
  },
  data() {
    return {
      mobileMenuView: false
    };
  },
  computed: {},
  watch: {
    mobileMenuView(value) {
      if (value) {
        this.$parent.$el.offsetParent.style.overflow = 'hidden';
      } else {
        this.$parent.$el.offsetParent.style.overflow = 'auto';
      }
    },
    '$route.path'(value) {
      this.$parent.$el.offsetParent.style.overflow = 'auto';
    }
  },
  mounted() {
    window.addEventListener('keydown', e => {
      if (e.keyCode === 27) {
        this.mobileMenuView = false;
      }
    });
  },
  methods: {
    popoverClick() {
      this.mobileMenuView = false;
    },
    userExit() {
      this.$emit('user-exit');
    },
    burgerShow(evt, el) {
      if (window.scrollY > 500) {
        el.classList.remove('no-view');
      } else {
        el.classList.add('no-view');
      }
    }
  }
};
</script>
